
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>MySQL · 捉虫动态 · 备库1206错误问题说明 / iVAN</title>

    <meta name="description" content="MySQL · 捉虫动态 · 备库1206错误问题说明 问题背景 一个用户自建MySQL,出现备库复制中断的问题,报错为slave sql thread 错误,The total number of locks exceeds the lock table size. 报错代码 这个报错在代码中的抛错逻辑为: if UT_LIST_GET_LEN(buf_pool-&gt;free) + UT_LIST_GET_LEN(buf_pool-&gt;LRU) &lt; buf_pool-&gt;curr_size / 4 文字解释是:如果buffer p ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">MySQL · 捉虫动态 · 备库1206错误问题说明</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h2>问题背景</h2>
<p>一个用户自建MySQL，出现备库复制中断的问题，报错为slave sql thread 错误，The total number of locks exceeds the lock table size。</p>
<h2>报错代码</h2>
<p>这个报错在代码中的抛错逻辑为：</p>
<pre><code>if UT_LIST_GET_LEN(buf_pool-&gt;free) + UT_LIST_GET_LEN(buf_pool-&gt;LRU) &lt; buf_pool-&gt;curr_size / 4
</code></pre>
<p>文字解释是：如果buffer pool中的空闲页面和LRU页面总和少于buffer pool 大小的1/4，则认为内存不够用，报错。</p>
<h2>那么问题来了</h2>
<ol>
<li><strong>buffer pool 哪里去了</strong><br />
  buffer pool是InnoDB内部管理内存的统一结构。默认每个page 16k。初始化后，每个page都是空闲状态，放在free中。<br />
  当读取数据等需要用到页面数据的操作时，将数据从磁盘读取到内存中，用的就是buffer pool的page。为了支持淘汰机制，InnoDB内部维护了一个淘汰链表，就是LRU list。装了数据的page被从free list移到LRU list。<br />
  但是，除了正常的读取数据，还有其他的逻辑需要从buffer pool中“抢”资源。比如本例中是因为undo page。<br />
  事务越大，需要的undo page越多，在整个事务未提交前，undo page是必须强占内存的。这就可能导致一种情况：事务过大，导致buffer pool全部被用光，无法提供正常服务。<br />
  因此InnoDB有了上面的保护机制。触发这个上限后报错后，事务会回滚，释放undo page。</li>
<li><strong>为什么主库执行成功备库失败了</strong><br />
  从上面的分析和代码中可以看到，判断内存是否占用过多，设置的上限是buffer_pool size的1/4. <br />
  另外，5.6以后支持了设置多个 innodb_buffer_pool_instances，也就是分成多个pool， 在现在的逻辑中，认为只要“任意一个pool满足上述超过1/4的条件”，都判定为内存消耗过限。<br />
  因此主要排查参数：</p>
<ul>
<li>备库的 innodb_buffer_pool_size 是否小于主库值</li>
<li>若主备的innodb_buffer_pool_size值相同，备库的 innodb_buffer_pool_instances 值是否更大。</li>
</ul>
</li>
<li><strong>作为验证</strong><br />
  DBA在发现备库apply error的时候第一步往往是用 mysqlbinlog 工具去看导致错误的event是什么。这时候会发现其实是一个批量的load数据，或者update/delete大事务导致。</li>
</ol>
<h2>小结</h2>
<ol>
<li>buffer pool不仅用于缓存page，会有其他数据结构争抢；</li>
<li>主备的参数尽量保持一致；</li>
<li>尽量避免超大事务，即使不考虑备库apply error。这种超大事务在主库执行，由于undo page占用buffer pool，可能会导致buffer pool命中率突然下降，影响业务。</li>
</ol>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-23 19:33:39</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e7%a3%81%e7%9b%98/" title="磁盘">磁盘</a>, <a href="https://www.iamivan.net/tag/mysql/" title="mysql">mysql</a>, <a href="https://www.iamivan.net/tag/list/" title="list">list</a>, <a href="https://www.iamivan.net/tag/%e6%95%b0%e6%8d%ae%e7%bb%93%e6%9e%84/" title="数据结构">数据结构</a>, <a href="https://www.iamivan.net/tag/page/" title="page">page</a>, <a href="https://www.iamivan.net/tag/innodb/" title="innodb">innodb</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>MySQL · 捉虫动态 · 备库1206错误问题说明的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqA9DOM.html" rel="bookmark">MySQL &CenterDot; 捉虫动态 &CenterDot; ALTER IGNORE TABLE导致主备不一致</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				背景 我们知道当一张表的某个字段存在重复值时,这个字段没办法直接加UNIQUE KEY,但是MySQL提供了一个 ALTER IGNORE TABLE的方式,可以忽略修改表结构过程中出现的错误,但是要忽略UNIQUE重复值,就需要打开old_alter_table,也就是拷贝表的方式来ALTER TABLE. 例如这样: CREATE TABLE t1(c1 int) ENGINE = InnoDB; INSERT INTO t1 VALUES (1), (1); SET old_alter_t			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b2Yx1qz.html" rel="bookmark">MySQL内核月报 2014&period;10-MySQL&CenterDot;　捉虫动态&CenterDot;从库OOM</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				bug背景 官方最近发布的版本(5.7.5)修复了这样一个bug,主备复制场景下,如果主库和备库对应的表结构中有数据类型不一致,并且主库的 binlog 是 row 格式的,这时候如果主库对不一致的表做了一个大事务更新,备库在应用 relay-log 的时候报OOM(Out of Memory).bug地址在这里,主备数据类型不一致主要发生在这2种情况下: 主备库版本不一致,不同版本之间的数据类型可能存在不一致.用户在报这个bug时,就是在5.5到5.6的复制场景下,用到了时间类型,时间类型在5			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mq73dKz.html" rel="bookmark">MySQL &CenterDot; 捉虫动态&CenterDot;DROP DATABASE外键约束的GTID BUG</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				背景 MySQL的DDL没有被设计成事务操作,因此DDL操作是无法回滚的(像PgSQL把DDL也设计成事务操作,DDL就可以在执行成功后被回滚操作取消).这就会导致如果某个DDL语句内部被拆分为多个原子的DDL调用,那么这个DDL语句就不具备中途执行失败后回滚整个DDL语句的能力,也就是说,即使语句逻辑内的某个原子DDL调用失败了,也无法回滚已经完成的那些原子DDL调用. 问题描述 DROP DATABASE 就是一个例子,对于MySQL而言,DROP DATABASE 并非是一个原子DDL操作			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVw46Yb.html" rel="bookmark">MySQL &CenterDot; 捉虫动态 &CenterDot; 并行复制外键约束问题二</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				背景 并行复制可以大大提高备库的 binlog 应用速度,内核月报也多次对并行复制特性进行介绍,感兴趣的朋友可以回顾下:5.6 并行复制实现分析.5.6 并行复制恢复实现 和 5.6并行复制事件分发机制. 在早期的内核月报,有一篇 并行复制外建约束问题,介绍阿里在 5.5 版本中自己实现并行复制时遇到的外键约束问题,本文接着前作继续介绍并行复制外键约束问题,这次场景不一样,并且目前官方 5.6 最新版本(5.6.30)中也有这个问题. 问题描述 一般情况的复制是 A-&gt;B 这样一主一备,本文要描			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdRjOAb.html" rel="bookmark">MySQL &CenterDot; 捉虫动态 &CenterDot; MySQL 外键异常分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				外键约束异常现象 如下测例中,没有违反引用约束的插入失败. create database `a-b`; use `a-b`; SET FOREIGN_KEY_CHECKS=0; create table t1(c1 int primary key, c2 int) engine=innodb; create table t2(c1 int primary key, c2 int) engine=innodb; alter table t2 add foreign key(c2) referen			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zZB2gkz.html" rel="bookmark">MySQL &CenterDot; 捉虫动态 &CenterDot; GTID下slave&lowbar;net&lowbar;timeout值太小问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				背景 官方 5.6 最新版本 5.6.24 有这样一个bugfix,当使用 GTID 协议进行复制,并且备库的 slave_net_timeout 值设置太小的话,备库的 slave io 线程会卡住,同时主库上的 binlog dump 线程数一直在涨,官方的bug地址 . bug分析 首先说明下几个概念: 1. slave_net_timeout,这个变量控制备库 IO 线程的连接超时,如果IO线程在指定时间内没有从主库收到数据的话,就断开重连,默认值是3600秒: 2. heartbeat			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z4YaB9b.html" rel="bookmark">MySQL &CenterDot; 捉虫动态 &CenterDot; Relay log 中 GTID group 完整性检测</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				bug背景 官方 5.7.6 版本对 gtid 有非常多的改进和bugfix,其中有一个 bugfix 是针对 relay log 中没有接收完整的 gtid 事务的.正常的relay log 中的 gtid 事务应该是像下面这样: 1. gtid event 2. query event (begin) 3. row event (write/update/delete) 4. query event (commit) 上面这 4 个 event 序列构成一个 group.因为 IO 线程从主			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M6Z5eOM.html" rel="bookmark">MySQL &CenterDot; 捉虫动态 &CenterDot; order by limit 造成优化器选择索引错误</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 bug 触发条件如下: 优化器先选择了 where 条件中字段的索引,该索引过滤性较好: SQL 中必须有 order by limit 从而引导优化器尝试使用 order by 字段上的索引进行优化,最终因代价问题没有成功. 复现case 表结构 create table t1( id int auto_increment primary key, a int, b int, c int, key iabc (a, b, c), key ic (c) ) engine = innod			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zOWAE5z.html" rel="bookmark">MySQL &CenterDot; 捉虫动态 &CenterDot; ORDER&sol;GROUP BY 导致 mysqld crash</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 表结构如下所示: show create table test\G Table: test Create Table: CREATE TABLE `test` ( `id` int(10) unsigned NOT NULL AUTO_INCREMENT, `id2` varchar(50) DEFAULT NULL `id3` varchar(100) DEFAULT NULL `some_text` varchar(200) DEFAULT NULL `name` varchar(			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/rz41Bjb.html" rel="bookmark" class="title">知道一个值jjfda&comma;如何查找它在那个表&comma;那个字段</a>
					<div>
						以Pubs为例,我现在知道一个值,'jjfda',但是不知道他在哪个表哪个字段  请问可以实现查询吗?  ----------------------------------------------- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qMq3eez.html" rel="bookmark" class="title">裴涛：百度算法的变化 新手们准备好了么？</a>
					<div>
						近期百度算法的频繁调整,我想广大站长朋友应该是深有体会,在各个SEO论坛板块,都是咨询&quot;新手如何去面对百度算法的变化&quot;在此裴涛跟大家分享一下个人观点. 一. 新站的审核期变短 由之 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1MvBl8M.html" rel="bookmark" class="title">一个简单实用的php加图片水印函数</a>
					<div>
						以下是引用片段:以下为引用的内容: &lt;?php     //$backFile:  背景图  //$copyFile:  待拷贝的图   //$resultFile:  生成文件保存地址  // ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vbQG6Kp.html" rel="bookmark" class="title">Flash MX中的ActionScript全集&lpar;五&rpar;</a>
					<div>
						targetpath定位路径 telltarget处于定点 textfield(object)文本框 textfield._alpha文本框可视度 textfield.addlistener文本框可用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YbKoN7b.html" rel="bookmark" class="title">ECC加密算法入门介绍</a>
					<div>
						加密|算法 ECC加密算法入门介绍 前言 同RSA(Ron Rivest,Adi Shamir,Len Adleman三位天才的名字)一样,ECC(Elliptic Curves Cryptograp ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM1Kydz.html" rel="bookmark" class="title">网站建设中容易疏忽的三个SEO问题</a>
					<div>
						现在各行各业的公司基本都建立了自己的网站,有的企业或公司建立自己网站,相当在网上安了家,可以说是在网上有了自己的名片,当客户想了解公司的时候,直接上网站上看资料或关于公司的简介.那么我们为企业或公司网 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7b2jlob.html" rel="bookmark" class="title">初学Delphi嵌入汇编&lbrack;20&rsqb;</a>
					<div>
						var I: Integer; begin //Integer 类型是4字节(32位)有符号整数, 最高位是符号位, 如果是正数, 符号位 是 0.负数的符号位是1 //所以 Integer 的最大值 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0P07nM.html" rel="bookmark" class="title">PS合成绚丽动感人物教程</a>
					<div>
						  在此例教程中,桂桂将会教你如何简单的合成一张绚丽的动感美女图,超级容易上手哦!还在等什么,快来学习吧!!! 分类: PS合成图片教程					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLOeoRM.html" rel="bookmark" class="title">利用qq拼音打游戏空格符号</a>
					<div>
						  首先要开始要打一个拼音;[zhu]找到特数字体[]输入到新建立的角色昵称中显示出来是空白,多打几次这个拼音,然后呢 系统会说你的角色在系统已经建立过了,这很简单.你再去打别的拼音去啊 找别的特殊 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVwNjnb.html" rel="bookmark" class="title">PhotoShop调出麦穗的金秋艺术色调的教程</a>
					<div>
						原片 效果 意境,只能意会不能言传,因此本例中的所有参数并非绝对,大家可以根据不同的图片进行调整. 打开图片,添加曲线调整图层,先要将天空的蓝色调整成深青绿色.进入蓝通道进行调整. 进入绿通道进行调整 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRwx8dp.html" rel="bookmark" class="title">用C实现OOP面向对象编程（1）</a>
					<div>
						如摘要所说,C语言不支持OOP(面向对象的编程).并这不意味着我们就不能对C进行面向对象的开发,只是过程要复杂许多.原来以C++的许多工作,在C语言中需我们手动去完成. 博主将与大家一起研究一下如下用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxWG9Qb.html" rel="bookmark" class="title">Gridview的一些问题</a>
					<div>
						问题描述 &lt;asp:GridViewID=&quot;GridView1&quot;runat=&quot;server&quot;DataSourceID=&quot;SqlDataSourc ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKkDQWb.html" rel="bookmark" class="title">【Oracle】利用在线重定义的方式改变普通表为分区表</a>
					<div>
						将普通表改为分区表有如下几种方式: 1 创建一个和原表一样的分区表A_NEW ;    将insert A_NEW SELECT * FROM A;    将表A 命名为A_OLD 将A_NEW 该名 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze6xQOb.html" rel="bookmark" class="title">用火狐下载文件出现很诡异的问题</a>
					<div>
						问题描述 用火狐下载文件出现很诡异的问题 在csdn上下载文件 文件后缀名总是自动多出一个'_' 更奇怪的是 下载下来会有两个同名文件 其中一个是空文件 删除空文件后缀名还会报错 说此文件不在这个路径 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrW5Byp.html" rel="bookmark" class="title">编程术语发音-编程术语的读音。。。</a>
					<div>
						问题描述 编程术语的读音... DAO EJB JDBC iBatis Strtus2,这些都没听过的,不知道怎么读. 解决方案 就按字母读吧:DAO EJBJDBC,都按字母读iBatis -- [ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRD368z.html" rel="bookmark" class="title">《Web测试囧事》&mdash;&mdash;1&period;4　利用JavaScript加载的漏洞提前购买抢购商品</a>
					<div>
						1.4 利用JavaScript加载的漏洞提前购买抢购商品 自从小米手机推出以来,抢购风潮在各类网站上盛行起来,小蔡测试的网站自然也不能免俗,项目组开发的网站也包含了抢购功能. 对于抢购来说,只有到了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnRKJ0p.html" rel="bookmark" class="title">android中UI主线程与子线程深入分析&lowbar;Android</a>
					<div>
						本文较为深入的分析了android中UI主线程与子线程.分享给大家供大家参考.具体如下: 在一个Android 程序开始运行的时候,会单独启动一个Process.默认的情况下,所有这个程序中的Acti ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPkAoZM.html" rel="bookmark" class="title">大虾们看看</a>
					<div>
						问题描述 &lt;?xmlversion=&quot;1.0&quot;encoding=&quot;UTF-8&quot;?&gt;&lt;!DOCTYPEstrutsPUBLIC&quot;-// ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgEVyEz.html" rel="bookmark" class="title">scala 学习笔记&lpar;06&rpar; OOP（下）多重继承 及 AOP</a>
					<div>
						一.多继承 上篇trait中,已经看到了其用法十分灵活,可以借此实现类似&quot;多重继承&quot;的效果,语法格式为: class/trait A extends B with C with D ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmVVdjz.html" rel="bookmark" class="title">PHP ajax 统计当前在线用户数程序代码</a>
					<div>
						我们要统计在一段时间内访问站点的人数,有多种解决方案,你可以使用cookie,session结合文本或者数据库来记录用户访问数.本文将使用PHP,结合Mysql以及jQuery,展示一个统计在线人数以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZ2wYOz.html" rel="bookmark" class="title">C 语言基础教程&lpar;我的C之旅开始了&rpar;&lbrack;九&rsqb;&lowbar;C 语言</a>
					<div>
						24. +.-.*./.= 的优先级 1. 优先级     和数学一样,C 语言规定先乘除后加减.也就是说,乘法运算符和除法运算符的优先级(Precedence)比加法运算符和减法运算符高.同时,C  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQ1KxQb.html" rel="bookmark" class="title">在ASP&period;NET 2&period;0中操作数据之三十二：数据控件的嵌套&lowbar;自学过程</a>
					<div>
						导言 除了静态HTML和数据绑定语法,template也可以包含Web控件和用户控件.这些控件的属性可以通过声明语法,数据绑定语法或在服务器端通过事件处理编程来设置. 通过将控件嵌入到template ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEYLwJb.html" rel="bookmark" class="title">减少无效URL的爬行和索引</a>
					<div>
						,原因包括: 1.大量过滤条件页面内容重复或极为类似(大量复制内容将使网站整体质量下降) 2.大量过滤条件页面没有对应产品,页面无内容(如选择&quot;100元以下42寸LED电视&quot;之类的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBkQPNM.html" rel="bookmark" class="title">一劳永逸  让你彻底和WIN10广告说拜拜</a>
					<div>
						也许是为了进一步增加营销收入和自身应用商店产品的推广力度,微软在Windows10开始在锁屏界面增加了广告投放功能.而周年更新之后,开始菜单也成为它们的展示区,一些来自官方推荐的应用和游戏,在无意点击 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPlrEmp.html" rel="bookmark" class="title">后台客服可以看到图片&comma;客户端聊天页面看不见图片是为什么&quest;急&excl;</a>
					<div>
						问题描述 跳转 chatViewController 赋值的 item_url 客户端内部不能点击吗?点击没反应,url 正确,传递的 image_url 后台客服可以看到图片,客户端聊天页面看不见图 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAkZg2z.html" rel="bookmark" class="title">c语言-关于图书管理系统借书和还书的问题</a>
					<div>
						问题描述 关于图书管理系统借书和还书的问题 想问问各位,用c写的图书馆管理系统里,借书和还书这两个功能怎么实现啊? 解决方案 你用的是链表还是把数据存储在文件里呢? 解决方案二: 可以把建立一个boo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9NXeKp.html" rel="bookmark" class="title">&period;js文件中的 javascript  无法在aspx页面中调用</a>
					<div>
						问题描述 同样的代码,放在live的服务器上本机访问没有问题,javascript运行很正常(debugjavascript的选项已经打开),但是在local运行的时候出现很多objectexpect ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjogenM.html" rel="bookmark" class="title">谷歌称在发布&OpenCurlyDoubleQuote;安卓O&rdquo;新版本前不会修复屏幕劫持漏洞</a>
					<div>
						谷歌称在发布&quot;安卓O&quot;新版本前不会修复屏幕劫持漏洞 数百万台安卓智能手机都遭受一个严重的&quot;屏幕劫持&quot;漏洞影响,黑客能窃取用户密码.银行详情以及帮助勒索软件app ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2JYnkb.html" rel="bookmark" class="title">初学者eclipse报错：not well-formed &lpar;invalid token&rpar;</a>
					<div>
						问题描述 初学者eclipse报错:not well-formed (invalid token) 新建有两个Activity用于两个Activity之间简单的切换,java文件跟xml文件都没问题了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvqaQWb.html" rel="bookmark" class="title">Flurry去年发布了关于移动设备的五年报告</a>
					<div>
						移动数据分析公司Flurry去年发布了关于移动设备的五年报告,昨天,Flurry将今年一月份至三月份的数据汇总,与五年报告中的结果进行比对,发现了一些新内容. 首先,与去年同期相比,美国用户花费在移动 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.027 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
